#!/usr/bin/perl -w

# LSB Test Execution Framework
# Help Page Module (tests_help.pl)
#
# Copyright (C) 2007 The Linux Foundation. All rights reserved.
#
# This program has been developed by ISP RAS for LF.
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
# # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #

use Templates;

print "HTTP/1.0 200 OK\n";
print "Content-type: text/html\n\n";

print_header("Information", "help");

print <<DATA;
<a name="top"></a>
<p align="justify"><b>LSB Application Testkit Manager</b> provides a web interface for executing LSB tests.</p><br />
<table style="border: dashed 1px #2f6fab; padding: 5px; padding-right: 10px; white-space: nowrap; background-color: #f9f9f9;"><tr><td>
<h3>Help Contents</h3>
<ol>
  <li><a href="#conf">Application Check</a>
    <ul>
      <li><a href="#browse">Browse pseudo-dialog</a></li>
      <li><a href="#browse_pkg">Select Packages pseudo-dialog</a></li>
    </ul>
  </li>
  <li><a href="#results">Results page</a>
    <ul>
      <li><a href="#report">Test Report page</a></li>
      <li><a href="#analysis">Analysis Report page</a></li>
      <li><a href="#upload">Upload page</a></li>
    </ul>
  </li>
  <li><a href="#help">Help page</a></li>
  <li><a href="#about">About page</a></li>
  <li><a href="#admin">Administration page</a></li>
  <li><a href="#troubleshooting">Troubleshooting</a></li>
</ol></td></tr>
</table>
<br />

<a name="conf"></a><h2>Application Check</h2>
<p align="justify">
This page allows you to configure the test system. The following options are present:
</p>
<ul>
<li><b>Application name:</b><br />Specify here name of the application you are going to test. It can be chosen arbitrarily and will only be used in reports, temporary file names, etc.</li>
<li><b>Files and directories:</b><br />In this field you can specify files and directories that belong to the application. Any combination of the following is allowed:
  <ol>
    <li>ELF executables;</li>
    <li>ELF shared objects;</li>
    <li>Perl scripts;</li>
    <li>Python scripts;</li>
    <li>directories with all contents;</li>
    <li>TAR.GZ packages;</li>
    <li>RPM packages.</li>
  </ol>
All non-ELF, non-Perl and non-Python files from directories, RPM and TAR.GZ packages will be ignored when testing, so that the report would not be overflowed with errors about every such file.<br />
<b>Note:</b> If you wish to avoid typing long names by hand, use the <b>Add File...</b> and <b>Add Directory...</b> buttons which open the <a href="#browse"><b>Browse pseudo-dialog</b></a> for visually selecting the files and directories.</li>
<li><b>Installed packages:</b><br />Here you can specify RPM or DEB packages (depending on your system) that are already installed. ATK Manager will get the list of the files of the packages selected and test them as if they were specified explicitly. As above, all non-ELF files will be ignored.<br />
<b>Note:</b> You can use the <b>Select Packages...</b> button to open the <a href="#browse_pkg"><b>Select Packages pseudo-dialog</b></a> where you can view all the packages installed and select them with checkboxes.</li>
<li><b>Architecture:</b><br />Allows to select the machine architecture. NOTE: Only architectures that are compatible with the machine being tested are listed.<br />
<i>Currently unsupported.</i></li>
<li><b>LSB Version:</b><br />This combobox specifies the LSB version to check against.</li>
<li><b>LSB Profile:</b><br />Allows to select the LSB profile to check against.</li>
<li><b>Comments:</b><br />Here you may write comments with any additional information. These comments are stored in the execution report and shown on the <a href="#results"><b>Results</b></a> page.</li>
</ul>
<p align="justify">
After you configured the settings you may press the button <b>Run the Test</b> located at the bottom of the page.
</p>

<a name="profile_management"></a><h3>User Profile Management</h3>
<p align="justify">
This section allows you to save/load all the settings listed above in different user profile files. To save the settings just specify the new profile name in the edit box (or use the drop-down list to select the existing profile and overwrite it), and then press the <b>Save</b> button. To load a previously saved profile, select it from the drop-down list and press <b>Load</b>. The <b>Delete</b> button allows you to delete the old profiles that are no longer needed.<br />
<b>Note:</b> The profile is not automatically saved when you run the tests! The settings are just stored in a temporary <i>session profile</i> which is automatically removed when it is no longer used. So if you wish to use the same set of options later, please save it explicitly, via the <b>Save</b> button.
</p>
<p align="right"><a href="#top">Back to top</a></p>

<a name="browse"></a><h2>Browse pseudo-dialog</h2>
<p align="justify">
This is a special page (pseudo-dialog) designed for easy selecting files and directories. The standard <b>Browse</b> dialog provided by the browser cannot be used for this purpose for the following reasons:
</p>
<ol>
  <li>This dialog shows the file system of the local machine, where the browser is opened. The ATK Manager can only test applications located on the same machine with itself; so if you are working with the ATK Manager remotely, the standard <b>Browse</b> will select wrong files (local instead of remote).</li>
  <li>This dialog does not allow selecting directories.</li>
  <li>Due to safety reasons, the standard Input File HTML control can be handled only manually, by the explicit user actions. Hence, it is not possible to restore its value when e.g. loading profiles.</li>
</ol>
<p align="justify">
The Browse pseudo-dialog shows the list of files/directories in the current directory. The current path is shown at the top; you can click any part of it to jump quickly to the corresponding directory.
</p>
<p align="justify">
There are two working modes: selecting a file and selecting a directory. The behaviour of the pseudo-dialog is slightly different in these modes.
</p>
<ol>
  <li>
    <b>Selecting a file</b>
    <ul>
      <li>To select a file, click the line with the name of the file.</li>
      <li>To go to a subdirectory, click the line with the name of the directory.</li>
    </ul>
  </li>
  <li>
    <b>Selecting a directory</b>
    <ul>
      <li>To select a directory, click its <b>name</b>.</li>
      <li>To go to a subdirectory, click the line with its name anywhere, <b>except</b> the name itself.</li>
    </ul>
  </li>
</ol>
<p align="justify">
To the left of the currently highlighted line you can see the icon which helps you quickly see what happens if you click where your mouse cursor is:
</p>
<ul>
  <li><img src="images/open_folder.gif" alt="" width="16" height="16" /> The subdirectory will be opened.</li>
  <li><img src="images/select_active.gif" alt="" width="16" height="16" /> The file or directory will be selected and the page will close.</li>
  <li><img src="images/select_inactive.gif" alt="" width="16" height="16" /> The file cannot be selected, so nothing will happen (this icon is shown for files when you need to select a directory).</li>
</ul>
<p align="right"><a href="#top">Back to top</a></p>

<a name="browse_pkg"></a><h2>Select Packages pseudo-dialog</h2>
<p align="justify">
This pseudo-dialog allows you to view and select the RPM or DEB packages installed in your system. For each package its name, version and release are shown (the latter is for RPMs only). You can select the packages using checkboxes on the left side and then press the <b>Finish</b> button to confirm selection. All the packages specified earlier in the <b>Installed packages</b> field are selected by default, so you don&lsquo;t need to reselect them. But if some of them cannot not be found, a warning is shown at the top of the page. Please, note that the <b>Finish</b> button will remove such packages from the <b>Installed packages</b> field.
</p>
<p align="right"><a href="#top">Back to top</a></p>

<a name="results"></a><h2>Results</h2>
<p align="justify">
This page shows the table with the full list of the tests execution results. The table contains the following columns:
</p>
<ul>
  <li><b>Date/Time</b><br />Here the date and time are shown, when the test was finished, as well as the name of the application tested. At the left edge of this column a status-icon is shown:
    <ul>
      <li><img src="images/TestsPassed.png" alt="Pass" width="33" height="30" /> The tests passed.</li>
      <li><img src="images/TestsFailed.png" alt="Fail" width="33" height="30" /> The tests failed.</li>
    </ul>
    In the cell&lsquo;s right-bottom corner there are several additional icons:
    <ul>
      <li><img src="images/report_details.gif" alt="" width="16" height="16" /> Clicking on this icon opens the <a href="#report"><b>Test Report</b></a> page for this test run (clicking the date/time link does the same).</li>
      <li><img src="images/report_summary.gif" alt="" width="16" height="16" /> Clicking on this icon opens the <a href="#analysis"><b>Analysis Report</b></a> page for this test run.</li>
      <li><img src="images/upload_data.png" alt="" width="16" height="16" /> This icon allows you to <a href="#upload"><b>upload</b></a> information about the application to the <a href="http://www.linux-foundation.org/" target="_blank">Linux Foundation</a> for publishing in the Linux Applications section of the <a href="http://www.linux-foundation.org/navigator/browse/app.php" target="_blank">LSB Navigator</a>. If you have already done it, the icon is not shown.</li>
    </ul>
  </li>
  <li><b>Summary</b><br />This column shows the general results of the tests (how many tests passed and failed).</li>
  <li><b>Comment</b><br />Here the comments entered on the <a href="#conf"><b>Application&nbsp;Check</b></a> page are shown.</li>
</ul>
<p align="justify">
To view the detailed particular report just click the link in the <b>Date/Time</b> field (see the <a href="#report"><b>Test Report page</b></a> section below for details).
</p>
<p align="justify">
To remove the reports that are no longer needed, just mark them with the checkboxes shown at the left edge of the corresponding lines and press the <b>Remove Selected Entries</b> button below the table.
</p>
<p align="right"><a href="#top">Back to top</a></p>

<a name="report"></a><h2>Test Report page</h2>
<p align="justify">
This page contains the detailed report about the test results. It consists of the following sections:
</p>
<ul>
<li><b>Test info</b><br />
Contains the information about the machine where the tests were executed.</li>
<li><b>Tests executed</b><br />
An index with links to details and a short summary for each test. The index is shown as a tree of files tested, each node being collapsable.<br />
<a name="No_result"></a>If <b>No result</b> for some item is shown, this means that the test failed to run or was interrupted during the execution.
</li>
<li><b>Details for each test</b><br />
    Here the information from the test journal is shown, including the list of warnings and errors detected. You may click any line with particular problem to see more details about this problem. The <b>Severity</b> column contains the status of the problem. Here are the descriptions for some of the status messages:
    <ul>
        <li><b>Warning</b> means that this some non-critical problem occured.</li>
        <li><b>Failed</b> means that a severe problem occured (it usually implies that the application is not LSB compliant).<br />For some types of problems a link is provided to the <a href="http://www.linux-foundation.org/navigator/commons/welcome.php" target="_blank">LSB Database Navigator</a> where you can find more information on the problem and, possibly, on how to solve it.</li>
        <li><a name="FIP"></a><b>FIP</b> stands for "<i>Futher Information Provided</i>". These FIP results occur when the test suite is unable to determine whether a result is a PASS or a FAIL. For LSB Certification you have to resolve each FIP case and upload your comments (in plain text) along with the test journals.</li>
        <!--li><b>Quelled</b> means that the problem is waived and will not prevent the distro from being LSB certified.</li-->
    </ul>
</li>
</ul>
<p align="justify">
You can use the test report for applying for LSB certification. To begin with the certification process, just click the <b>apply for certification</b> link. You will be redirected to the <a href="http://$cert_sys_host$cert_sys_base" target="_blank">Certification System</a>. If necessary, you will be suggested to register, create your company and product you are going to certify.
</p>
<p align="right"><a href="#top">Back to top</a></p>

<a name="analysis"></a><h2>Analysis Report page</h2>
<p align="justify">
On this page you can see the list of the libraries and interfaces needed by the application.
</p>
<ul>
<li><b>List of Required Libraries</b><br />
The table contains the list of the external libraries that are required for the application to run. The following columns are shown:
  <ol>
    <li><b>Library</b><br />The so-called <i>soname</i> of the library (the real name in the file system).</li>
    <li><b>In LSB?</b><br />This flag shows whether the library is in LSB or not.</li>
    <li><b>Application Modules</b><br />The list of particular modules of the application tested that require the library.</li>
    <li><b>Comments</b><br />Here some additional information can be present about the library or how to eliminate the LSB inconsistency.</li>
  </ol>
</li>
<li><b>List of Required Interfaces</b><br />
In this table the external interfaces are listed that are required by the application to run. The following columns are shown:
  <ol>
    <li><b>Interface</b><br />The name of the interface. Please note that some names can be mangled.</li>
    <li><b>Library</b><br />Name of the library providing the interface.</li>
    <li><b>In LSB?</b><br />This flag shows whether the interface is in LSB or not.</li>
    <li><b>Application Modules</b><br />The list of particular modules of the application tested that require the interface.</li>
    <li><b>Comments</b><br />Here some additional information can be present about the interface or how to eliminate the LSB inconsistency.</li>
  </ol>
</li>
</ul>
<p align="justify">
Both tables have filters allowing to show only non-LSB entries (default), only LSB entries or both.
</p>
<p align="right"><a href="#top">Back to top</a></p>

<a name="upload"></a><h2>Upload page</h2>
<p align="justify">
This page allows you to send the information about the application to the Linux Foundation so that it was added to the <a href="http://www.linux-foundation.org/navigator/browse/app.php" target="_blank">LSB Navigator</a> (the Linux Applications section). The following fields are present:
</p>
<ul>
  <li><b>Contact name</b><br />Name of the person uploading the data.</li>
  <li><b>E-mail</b><br />Contact E-mail (it will be used for notification about adding the application to the LSB Navigator database).</li>
  <li><b>Application name</b><br />Name of the application. By default it contains the name specified on the <a href="#conf"><b>Application&nbsp;Check</b></a> page.</li>
  <li><b>Application version</b><br />Version of the application.</li>
  <li><b>User interface style</b><br />Specify if your application has graphical or console user interface.</li>
  <li><b>License type</b><br />Specify the license type your application is distributed under (Open Source or Proprietary).</li>
  <li><b>Application homepage</b><br />Homepage of the application (if any).</li>
  <li><b>Comments</b><br />If you have any comments, please write them here.</li>
</ul>
<p align="justify">
The mandatory fields are marked with red asterisks.
</p>
<p align="justify">
Below the form the link <b>View the file to be sent</b> is present. It allows you to check the contents of the file which is going to be uploaded to the Linux Foundation.
</p>
<p align="right"><a href="#top">Back to top</a></p>

<a name="help"></a><h2>Help</h2>
<p align="justify">
Contains the description of the web-interface of LSB Application Testkit (the page you are reading now).
</p>
<p align="right"><a href="#top">Back to top</a></p>

<a name="about"></a><h2>About</h2>
<p align="justify">
Contains the general information about LSB Application Testkit: its version, license, etc.
</p>
<p align="right"><a href="#top">Back to top</a></p>

<a name="admin"></a><h2>Administration</h2>
<p align="justify">
This page is designed for performing administrative tasks. Please be careful doing anything on this page!
</p>
<p align="justify">
Currently the following items are present:
</p>
<ul>
<li><b>Server status:</b><br />Shows current status of the web-server and its PID. The button <b>Stop server</b> shuts the server down. Please note that you will not be able to use the web interface after that!</li>
</ul>
<p align="right"><a href="#top">Back to top</a></p>

<a name="troubleshooting"></a><h2>Troubleshooting</h2>
<p align="justify">
Please, write to <a href="mailto:linux\@ispras.ru">linux\@ispras.ru</a> if you meet any troubles.
</p>
<p align="right"><a href="#top">Back to top</a></p>
DATA

print_footer();
